unit frmRadiobox;

{ https://forum.lazarus.freepascal.org/index.php/topic,60717.0.html?PHPSESSID=l1vtb3loamsjbth1c8l3lm80a7 }

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls;
type

  { TfmRadiobox }

  TfmRadiobox = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    stItem: TStaticText;
    procedure FormShow(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    FFirstShown : boolean;
  public

  end;

var
  fmRadiobox: TfmRadiobox;

implementation

{$R *.lfm}

{ TfmRadiobox }

procedure TfmRadiobox.RadioGroup1Click(Sender: TObject);
const
  cStaticUpdateCount: integer = 0;
var
  lRadioGroup, lSelRadioGroup: TRadioGroup;
  ixRG: integer = 0;
  ixRGIt: integer = -1;
  ixGBItem: integer = 0;
  lMemoLine : string;
begin
  if cStaticUpdateCount<1 then begin
    Inc(cStaticUpdateCount);
    if Sender is TRadioGroup then begin
      lSelRadioGroup := TRadioGroup(Sender);
      with GroupBox1 do begin
        for ixRG := 0 to ControlCount- 1 do
          if Controls[ixRG] is TRadioGroup then begin
            lRadioGroup := TRadioGroup(Controls[ixRG]);
            if lRadioGroup = lSelRadioGroup then begin
              ixRGIt := lSelRadioGroup.ItemIndex;
              ixGBItem := ixGBItem + ixRGIt;
            end
            else begin
              lRadioGroup.ItemIndex := -1;
              if ixRGIt<0 then
                ixGBItem := ixGBItem + lRadioGroup.Items.Count;
            end;
          end;
      end;
      lMemoLine := lSelRadioGroup.Caption +  ' Item=' +
        lSelRadioGroup.Items[lSelRadioGroup.ItemIndex] +  ' GroupBox.ItemIndex=' +
        IntToStr(ixGBItem);
      stItem.Caption := lMemoLine;
      self.Memo1.Lines.Insert(0, lMemoLine);
    end;
    Dec(cStaticUpdateCount);
  end;
end;

procedure TfmRadiobox.FormShow(Sender: TObject);
begin
  if not FFirstShown then begin
    Memo1.Lines.Clear;
    FFirstShown := True;
  end;
end;

end.
